* C-Minus Compilation to TM Code
* File: array.tm
* Standard prelude:
  0:     LD  6,0(0) 	 load gp with maxaddress
  1:    LDA  5,0(6) 	 copy gp to fp
  2:     ST  0,0(0) 	 clear location 0
* call to main occurs here
* code for input routine
  7:     ST  0,-1(5) 	 store return
  8:     IN  0,0,0 	input
  9:     LD  7,-1(5) 	 return to caller
* code for output routine
 10:     ST  0,-1(5) 	 store return
 11:     LD  0,-2(5) 	 load output value
 12:    OUT  0,0,0 	output
 13:     LD  7,-1(5) 	 return to caller
* End of standard prelude.
* Processing array var x
* -> fundecl read
* Processing array param a
 14:     ST  0,-1(5) 	 store return
* Processing simple var n
* -> op
* -> id n
 15:    LDA  0,-3(5) 	 load id address
* <- id n
 16:     ST  0,-4(5) 	 op: push left
* -> const
 17:    LDC  0,0(0) 	 load const
* <- const
 18:     LD  1,-4(5) 	 op: load left
 19:     ST  0,0(1) 	 assign: store value
* <- op
* -> while
* while: jump after body comes back here
* -> op
* -> id n
 20:     LD  0,-3(5) 	 load id value
* <- id n
 21:     ST  0,-4(5) 	 op: push left
* -> const
 22:    LDC  0,5(0) 	 load const
* <- const
 23:     LD  1,-4(5) 	 op: load left
 24:    SUB  0,1,0 	op <
 25:    JLT  0,2(7) 	 br if true
 26:    LDC  0,0(0) 	 false case
 27:    LDA  7,1(7) 	 unconditional jmp
 28:    LDC  0,1(0) 	 true case
* <- op
* while: jump to end belongs here
* -> op
* -> subs a
* -> id n
 30:     LD  0,-3(5) 	 load id value
* <- id n
 31:    JLT  0,1(7) 	 halt if subscript < 0
 32:    LDA  7,1(7) 	 absolute jump if not
 33:   HALT  0,0,0 	halt if subscript < 0
 34:     LD  1,-2(5) 	 load array base from param
 35:    SUB  0,1,0 	base is at top of array
* <- subs a
 36:     ST  0,-4(5) 	 op: push left
* -> call input
 37:     ST  5,-5(5) 	 push ofp
 38:    LDA  5,-5(5) 	 push frame
 39:    LDA  0,1(7) 	 load ac with ret ptr
 40:    LDA  7,-34(7) 	 jump to fun loc
 41:     LD  5,0(5) 	 pop frame
* <- call input
 42:     LD  1,-4(5) 	 op: load left
 43:     ST  0,0(1) 	 assign: store value
* <- op
* -> op
* -> id n
 44:    LDA  0,-3(5) 	 load id address
* <- id n
 45:     ST  0,-4(5) 	 op: push left
* -> op
* -> id n
 46:     LD  0,-3(5) 	 load id value
* <- id n
 47:     ST  0,-5(5) 	 op: push left
* -> const
 48:    LDC  0,1(0) 	 load const
* <- const
 49:     LD  1,-5(5) 	 op: load left
 50:    ADD  0,1,0 	op +
* <- op
 51:     LD  1,-4(5) 	 op: load left
 52:     ST  0,0(1) 	 assign: store value
* <- op
 53:    LDA  7,-34(7) 	 while: absolute jmp to test
 29:    JEQ  0,24(7) 	 while: jmp to end
* <- while
 54:     LD  7,-1(5) 	 return to caller
* <- fundecl read
* -> fundecl write
* Processing array param a
 55:     ST  0,-1(5) 	 store return
* Processing simple var n
* -> op
* -> id n
 56:    LDA  0,-3(5) 	 load id address
* <- id n
 57:     ST  0,-4(5) 	 op: push left
* -> const
 58:    LDC  0,0(0) 	 load const
* <- const
 59:     LD  1,-4(5) 	 op: load left
 60:     ST  0,0(1) 	 assign: store value
* <- op
* -> while
* while: jump after body comes back here
* -> op
* -> id n
 61:     LD  0,-3(5) 	 load id value
* <- id n
 62:     ST  0,-4(5) 	 op: push left
* -> const
 63:    LDC  0,5(0) 	 load const
* <- const
 64:     LD  1,-4(5) 	 op: load left
 65:    SUB  0,1,0 	op <
 66:    JLT  0,2(7) 	 br if true
 67:    LDC  0,0(0) 	 false case
 68:    LDA  7,1(7) 	 unconditional jmp
 69:    LDC  0,1(0) 	 true case
* <- op
* while: jump to end belongs here
* -> call output
* -> subs x
* -> id n
 71:     LD  0,-3(5) 	 load id value
* <- id n
 72:    JLT  0,1(7) 	 halt if subscript < 0
 73:    LDA  7,1(7) 	 absolute jump if not
 74:   HALT  0,0,0 	halt if subscript < 0
 75:    LDA  1,0(6) 	 load array base addr
 76:    SUB  0,1,0 	base is at top of array
 77:     LD  0,0(0) 	 load value at array index
* <- subs x
 78:     ST  0,-6(5) 	 store arg val
 79:     ST  5,-4(5) 	 push ofp
 80:    LDA  5,-4(5) 	 push frame
 81:    LDA  0,1(7) 	 load ac with ret ptr
 82:    LDA  7,-73(7) 	 jump to fun loc
 83:     LD  5,0(5) 	 pop frame
* <- call output
* -> op
* -> id n
 84:    LDA  0,-3(5) 	 load id address
* <- id n
 85:     ST  0,-4(5) 	 op: push left
* -> op
* -> id n
 86:     LD  0,-3(5) 	 load id value
* <- id n
 87:     ST  0,-5(5) 	 op: push left
* -> const
 88:    LDC  0,1(0) 	 load const
* <- const
 89:     LD  1,-5(5) 	 op: load left
 90:    ADD  0,1,0 	op +
* <- op
 91:     LD  1,-4(5) 	 op: load left
 92:     ST  0,0(1) 	 assign: store value
* <- op
 93:    LDA  7,-33(7) 	 while: absolute jmp to test
 70:    JEQ  0,23(7) 	 while: jmp to end
* <- while
 94:     LD  7,-1(5) 	 return to caller
* <- fundecl write
* -> fundecl main
 95:     ST  0,-1(5) 	 store return
* -> call read
* -> id x
 96:    LDA  0,0(6) 	 load id address
* <- id x
 97:     ST  0,-4(5) 	 store arg val
 98:     ST  5,-2(5) 	 push ofp
 99:    LDA  5,-2(5) 	 push frame
100:    LDA  0,1(7) 	 load ac with ret ptr
101:    LDA  7,-88(7) 	 jump to fun loc
102:     LD  5,0(5) 	 pop frame
* <- call read
* -> call write
* -> id x
103:    LDA  0,0(6) 	 load id address
* <- id x
104:     ST  0,-4(5) 	 store arg val
105:     ST  5,-2(5) 	 push ofp
106:    LDA  5,-2(5) 	 push frame
107:    LDA  0,1(7) 	 load ac with ret ptr
108:    LDA  7,-54(7) 	 jump to fun loc
109:     LD  5,0(5) 	 pop frame
* <- call write
110:     LD  7,-1(5) 	 return to caller
* <- fundecl main
* Backpatch call to main
  3:     ST  5,-5(5) 	 push ofp
  4:    LDA  5,-5(5) 	 push frame
  5:    LDC  0,111(0) 	 load ac with end of main
  6:    LDA  7,88(7) 	 jump to main loc
111:     LD  5,0(5) 	 pop frame
* End of execution.
112:   HALT  0,0,0 	
