* C-Minus Compilation to TM Code
* File: array2.tm
* Standard prelude:
  0:     LD  6,0(0) 	 load gp with maxaddress
  1:    LDA  5,0(6) 	 copy gp to fp
  2:     ST  0,0(0) 	 clear location 0
* call to main occurs here
* code for input routine
  7:     ST  0,-1(5) 	 store return
  8:     IN  0,0,0 	input
  9:     LD  7,-1(5) 	 return to caller
* code for output routine
 10:     ST  0,-1(5) 	 store return
 11:     LD  0,-2(5) 	 load output value
 12:    OUT  0,0,0 	output
 13:     LD  7,-1(5) 	 return to caller
* End of standard prelude.
* Processing array var x
* -> fundecl read
* Processing array param a
 14:     ST  0,-1(5) 	 store return
* Processing simple var n
* -> op
* -> id n
 15:    LDA  0,-3(5) 	 load id address
* <- id n
 16:     ST  0,-4(5) 	 op: push left
* -> const
 17:    LDC  0,0(0) 	 load const
* <- const
 18:     LD  1,-4(5) 	 op: load left
 19:     ST  0,0(1) 	 assign: store value
* <- op
* -> while
* while: jump after body comes back here
* -> op
* -> id n
 20:     LD  0,-3(5) 	 load id value
* <- id n
 21:     ST  0,-4(5) 	 op: push left
* -> const
 22:    LDC  0,5(0) 	 load const
* <- const
 23:     LD  1,-4(5) 	 op: load left
 24:    SUB  0,1,0 	op <
 25:    JLT  0,2(7) 	 br if true
 26:    LDC  0,0(0) 	 false case
 27:    LDA  7,1(7) 	 unconditional jmp
 28:    LDC  0,1(0) 	 true case
* <- op
* while: jump to end belongs here
* -> op
* -> subs a
* -> id n
 30:     LD  0,-3(5) 	 load id value
* <- id n
 31:    JLT  0,1(7) 	 halt if subscript < 0
 32:    LDA  7,1(7) 	 absolute jump if not
 33:   HALT  0,0,0 	halt if subscript < 0
 34:     LD  1,-2(5) 	 load array base from param
 35:    SUB  0,1,0 	base is at top of array
* <- subs a
 36:     ST  0,-4(5) 	 op: push left
* -> call input
 37:     ST  5,-5(5) 	 push ofp
 38:    LDA  5,-5(5) 	 push frame
 39:    LDA  0,1(7) 	 load ac with ret ptr
 40:    LDA  7,-34(7) 	 jump to fun loc
 41:     LD  5,0(5) 	 pop frame
* <- call input
 42:     LD  1,-4(5) 	 op: load left
 43:     ST  0,0(1) 	 assign: store value
* <- op
* -> op
* -> id n
 44:    LDA  0,-3(5) 	 load id address
* <- id n
 45:     ST  0,-4(5) 	 op: push left
* -> op
* -> id n
 46:     LD  0,-3(5) 	 load id value
* <- id n
 47:     ST  0,-5(5) 	 op: push left
* -> const
 48:    LDC  0,1(0) 	 load const
* <- const
 49:     LD  1,-5(5) 	 op: load left
 50:    ADD  0,1,0 	op +
* <- op
 51:     LD  1,-4(5) 	 op: load left
 52:     ST  0,0(1) 	 assign: store value
* <- op
 53:    LDA  7,-34(7) 	 while: absolute jmp to test
 29:    JEQ  0,24(7) 	 while: jmp to end
* <- while
 54:     LD  7,-1(5) 	 return to caller
* <- fundecl read
* -> fundecl main
 55:     ST  0,-1(5) 	 store return
* Processing array var a
* Processing simple var n
* -> call read
* -> id x
 56:    LDA  0,0(6) 	 load id address
* <- id x
 57:     ST  0,-10(5) 	 store arg val
 58:     ST  5,-8(5) 	 push ofp
 59:    LDA  5,-8(5) 	 push frame
 60:    LDA  0,1(7) 	 load ac with ret ptr
 61:    LDA  7,-48(7) 	 jump to fun loc
 62:     LD  5,0(5) 	 pop frame
* <- call read
* -> op
* -> id n
 63:    LDA  0,-7(5) 	 load id address
* <- id n
 64:     ST  0,-8(5) 	 op: push left
* -> const
 65:    LDC  0,0(0) 	 load const
* <- const
 66:     LD  1,-8(5) 	 op: load left
 67:     ST  0,0(1) 	 assign: store value
* <- op
* -> while
* while: jump after body comes back here
* -> op
* -> id n
 68:     LD  0,-7(5) 	 load id value
* <- id n
 69:     ST  0,-8(5) 	 op: push left
* -> const
 70:    LDC  0,5(0) 	 load const
* <- const
 71:     LD  1,-8(5) 	 op: load left
 72:    SUB  0,1,0 	op <
 73:    JLT  0,2(7) 	 br if true
 74:    LDC  0,0(0) 	 false case
 75:    LDA  7,1(7) 	 unconditional jmp
 76:    LDC  0,1(0) 	 true case
* <- op
* while: jump to end belongs here
* -> op
* -> subs a
* -> id n
 78:     LD  0,-7(5) 	 load id value
* <- id n
 79:    JLT  0,1(7) 	 halt if subscript < 0
 80:    LDA  7,1(7) 	 absolute jump if not
 81:   HALT  0,0,0 	halt if subscript < 0
 82:    LDA  1,-2(5) 	 load array base addr
 83:    SUB  0,1,0 	base is at top of array
* <- subs a
 84:     ST  0,-8(5) 	 op: push left
* -> subs x
* -> id n
 85:     LD  0,-7(5) 	 load id value
* <- id n
 86:    JLT  0,1(7) 	 halt if subscript < 0
 87:    LDA  7,1(7) 	 absolute jump if not
 88:   HALT  0,0,0 	halt if subscript < 0
 89:    LDA  1,0(6) 	 load array base addr
 90:    SUB  0,1,0 	base is at top of array
 91:     LD  0,0(0) 	 load value at array index
* <- subs x
 92:     LD  1,-8(5) 	 op: load left
 93:     ST  0,0(1) 	 assign: store value
* <- op
* -> op
* -> id n
 94:    LDA  0,-7(5) 	 load id address
* <- id n
 95:     ST  0,-8(5) 	 op: push left
* -> op
* -> id n
 96:     LD  0,-7(5) 	 load id value
* <- id n
 97:     ST  0,-9(5) 	 op: push left
* -> const
 98:    LDC  0,1(0) 	 load const
* <- const
 99:     LD  1,-9(5) 	 op: load left
100:    ADD  0,1,0 	op +
* <- op
101:     LD  1,-8(5) 	 op: load left
102:     ST  0,0(1) 	 assign: store value
* <- op
103:    LDA  7,-36(7) 	 while: absolute jmp to test
 77:    JEQ  0,26(7) 	 while: jmp to end
* <- while
* -> op
* -> id n
104:    LDA  0,-7(5) 	 load id address
* <- id n
105:     ST  0,-8(5) 	 op: push left
* -> const
106:    LDC  0,4(0) 	 load const
* <- const
107:     LD  1,-8(5) 	 op: load left
108:     ST  0,0(1) 	 assign: store value
* <- op
* -> while
* while: jump after body comes back here
* -> op
* -> id n
109:     LD  0,-7(5) 	 load id value
* <- id n
110:     ST  0,-8(5) 	 op: push left
* -> const
111:    LDC  0,0(0) 	 load const
* <- const
112:     LD  1,-8(5) 	 op: load left
113:    SUB  0,1,0 	op >=
114:    JGE  0,2(7) 	 br if true
115:    LDC  0,0(0) 	 false case
116:    LDA  7,1(7) 	 unconditional jmp
117:    LDC  0,1(0) 	 true case
* <- op
* while: jump to end belongs here
* -> call output
* -> subs a
* -> id n
119:     LD  0,-7(5) 	 load id value
* <- id n
120:    JLT  0,1(7) 	 halt if subscript < 0
121:    LDA  7,1(7) 	 absolute jump if not
122:   HALT  0,0,0 	halt if subscript < 0
123:    LDA  1,-2(5) 	 load array base addr
124:    SUB  0,1,0 	base is at top of array
125:     LD  0,0(0) 	 load value at array index
* <- subs a
126:     ST  0,-10(5) 	 store arg val
127:     ST  5,-8(5) 	 push ofp
128:    LDA  5,-8(5) 	 push frame
129:    LDA  0,1(7) 	 load ac with ret ptr
130:    LDA  7,-121(7) 	 jump to fun loc
131:     LD  5,0(5) 	 pop frame
* <- call output
* -> op
* -> id n
132:    LDA  0,-7(5) 	 load id address
* <- id n
133:     ST  0,-8(5) 	 op: push left
* -> op
* -> id n
134:     LD  0,-7(5) 	 load id value
* <- id n
135:     ST  0,-9(5) 	 op: push left
* -> const
136:    LDC  0,1(0) 	 load const
* <- const
137:     LD  1,-9(5) 	 op: load left
138:    SUB  0,1,0 	op -
* <- op
139:     LD  1,-8(5) 	 op: load left
140:     ST  0,0(1) 	 assign: store value
* <- op
141:    LDA  7,-33(7) 	 while: absolute jmp to test
118:    JEQ  0,23(7) 	 while: jmp to end
* <- while
142:     LD  7,-1(5) 	 return to caller
* <- fundecl main
* Backpatch call to main
  3:     ST  5,-5(5) 	 push ofp
  4:    LDA  5,-5(5) 	 push frame
  5:    LDC  0,143(0) 	 load ac with end of main
  6:    LDA  7,48(7) 	 jump to main loc
143:     LD  5,0(5) 	 pop frame
* End of execution.
144:   HALT  0,0,0 	
