* C-Minus Compilation to TM Code
* File: fact.tm
* Standard prelude:
  0:     LD  6,0(0) 	 load gp with maxaddress
  1:    LDA  5,0(6) 	 copy gp to fp
  2:     ST  0,0(0) 	 clear location 0
* call to main occurs here
* code for input routine
  7:     ST  0,-1(5) 	 store return
  8:     IN  0,0,0 	input
  9:     LD  7,-1(5) 	 return to caller
* code for output routine
 10:     ST  0,-1(5) 	 store return
 11:     LD  0,-2(5) 	 load output value
 12:    OUT  0,0,0 	output
 13:     LD  7,-1(5) 	 return to caller
* End of standard prelude.
* -> fundecl fact
* Processing simple param x
 14:     ST  0,-1(5) 	 store return
* -> if
* -> op
* -> id x
 15:     LD  0,-2(5) 	 load id value
* <- id x
 16:     ST  0,-3(5) 	 op: push left
* -> const
 17:    LDC  0,1(0) 	 load const
* <- const
 18:     LD  1,-3(5) 	 op: load left
 19:    SUB  0,1,0 	op >
 20:    JGT  0,2(7) 	 br if true
 21:    LDC  0,0(0) 	 false case
 22:    LDA  7,1(7) 	 unconditional jmp
 23:    LDC  0,1(0) 	 true case
* <- op
* if: jump to else belongs here
* -> return
* -> op
* -> id x
 25:     LD  0,-2(5) 	 load id value
* <- id x
 26:     ST  0,-3(5) 	 op: push left
* -> call fact
* -> op
* -> id x
 27:     LD  0,-2(5) 	 load id value
* <- id x
 28:     ST  0,-6(5) 	 op: push left
* -> const
 29:    LDC  0,1(0) 	 load const
* <- const
 30:     LD  1,-6(5) 	 op: load left
 31:    SUB  0,1,0 	op -
* <- op
 32:     ST  0,-6(5) 	 store arg val
 33:     ST  5,-4(5) 	 push ofp
 34:    LDA  5,-4(5) 	 push frame
 35:    LDA  0,1(7) 	 load ac with ret ptr
 36:    LDA  7,-23(7) 	 jump to fun loc
 37:     LD  5,0(5) 	 pop frame
* <- call fact
 38:     LD  1,-3(5) 	 op: load left
 39:    MUL  0,1,0 	op *
* <- op
 40:     LD  7,-1(5) 	 return to caller
* <- return
* if: jump to end belongs here
 24:    JEQ  0,17(7) 	 if: jmp to else
* -> return
* -> const
 42:    LDC  0,1(0) 	 load const
* <- const
 43:     LD  7,-1(5) 	 return to caller
* <- return
 41:    LDA  7,2(7) 	 jmp to end
* <- if
 44:     LD  7,-1(5) 	 return to caller
* <- fundecl fact
* -> fundecl main
 45:     ST  0,-1(5) 	 store return
* Processing simple var x
* -> op
* -> id x
 46:    LDA  0,-2(5) 	 load id address
* <- id x
 47:     ST  0,-3(5) 	 op: push left
* -> call input
 48:     ST  5,-4(5) 	 push ofp
 49:    LDA  5,-4(5) 	 push frame
 50:    LDA  0,1(7) 	 load ac with ret ptr
 51:    LDA  7,-45(7) 	 jump to fun loc
 52:     LD  5,0(5) 	 pop frame
* <- call input
 53:     LD  1,-3(5) 	 op: load left
 54:     ST  0,0(1) 	 assign: store value
* <- op
* -> if
* -> op
* -> id x
 55:     LD  0,-2(5) 	 load id value
* <- id x
 56:     ST  0,-3(5) 	 op: push left
* -> const
 57:    LDC  0,0(0) 	 load const
* <- const
 58:     LD  1,-3(5) 	 op: load left
 59:    SUB  0,1,0 	op >
 60:    JGT  0,2(7) 	 br if true
 61:    LDC  0,0(0) 	 false case
 62:    LDA  7,1(7) 	 unconditional jmp
 63:    LDC  0,1(0) 	 true case
* <- op
* if: jump to else belongs here
* -> call output
* -> call fact
* -> id x
 65:     LD  0,-2(5) 	 load id value
* <- id x
 66:     ST  0,-7(5) 	 store arg val
 67:     ST  5,-5(5) 	 push ofp
 68:    LDA  5,-5(5) 	 push frame
 69:    LDA  0,1(7) 	 load ac with ret ptr
 70:    LDA  7,-57(7) 	 jump to fun loc
 71:     LD  5,0(5) 	 pop frame
* <- call fact
 72:     ST  0,-5(5) 	 store arg val
 73:     ST  5,-3(5) 	 push ofp
 74:    LDA  5,-3(5) 	 push frame
 75:    LDA  0,1(7) 	 load ac with ret ptr
 76:    LDA  7,-67(7) 	 jump to fun loc
 77:     LD  5,0(5) 	 pop frame
* <- call output
* if: jump to end belongs here
 64:    JEQ  0,14(7) 	 if: jmp to else
 78:    LDA  7,0(7) 	 jmp to end
* <- if
 79:     LD  7,-1(5) 	 return to caller
* <- fundecl main
* Backpatch call to main
  3:     ST  5,0(5) 	 push ofp
  4:    LDA  5,0(5) 	 push frame
  5:    LDC  0,80(0) 	 load ac with end of main
  6:    LDA  7,38(7) 	 jump to main loc
 80:     LD  5,0(5) 	 pop frame
* End of execution.
 81:   HALT  0,0,0 	
